/*
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements. See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership. The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied. See the License for the
 * specific language governing permissions and limitations
 * under the License.
 */
package org.apache.deltaspike.jsf.api.config.base;

import org.apache.deltaspike.core.api.config.base.CoreBaseConfig;
import org.apache.deltaspike.core.api.config.base.TypedConfig;
import org.apache.deltaspike.jsf.api.config.view.Folder;
import org.apache.deltaspike.jsf.api.config.view.View;

public interface JsfBaseConfig
{
    interface ViewConfig
    {
        TypedConfig<String> CUSTOM_DEFAULT_BASE_PATH_BUILDER =
            new TypedConfig<String>(View.DefaultBasePathBuilder.class.getName(), null, String.class);

        TypedConfig<String> CUSTOM_DEFAULT_FILE_NAME_BUILDER =
            new TypedConfig<String>(View.DefaultFileNameBuilder.class.getName(), null, String.class);

        TypedConfig<String> CUSTOM_DEFAULT_EXTENSION_BUILDER =
            new TypedConfig<String>(View.DefaultExtensionBuilder.class.getName(), null, String.class);

        TypedConfig<String> CUSTOM_DEFAULT_FOLDER_NAME_BUILDER =
            new TypedConfig<String>(Folder.DefaultFolderNameBuilder.class.getName(), null, String.class);
    }

    interface Scope
    {
        interface Window
        {
            TypedConfig<Integer> MAX_COUNT =
                new TypedConfig<Integer>(CoreBaseConfig.Scope.Window.MAX_COUNT.getKey(), 64);

            //10 is enough for the integer generated by DefaultClientWindow#generateNewWindowId - see DELTASPIKE-752
            TypedConfig<Integer> ID_MAX_LENGTH =
                new TypedConfig<Integer>("deltaspike.window-id.max_length", 10);
        }

        interface View
        {
            TypedConfig<Boolean> DELEGATE_TO_JSF =
                new TypedConfig<Boolean>("deltaspike.scope.view.delegate", Boolean.TRUE);
        }
    }
}
